-- I wonder what this is for?
-- I kid, I kid, this is obviously for SRB2Persona!
 
-- Hey, you bothered checking the files. If this is included in an unrelated character release, surely this means something... right?
-- PS: SRB2P custom character support works, but is rough.
-- There are NO failsafes if you fuck up declarations, so read the comments here.
 
if not srb2p return end
-- Due to the exe nature of the mod, this only requires a one-time check.
 
-- Define our base character's stats!
charStats["sonki"] = {
 
        -- GENERAL
 
        name = "Sonki",        -- This is only for bots / enemies
        basehp = 68,            -- base HP for level 1 (Cannot be <= 0)
        basesp = 20,            -- base SP for level 1 (Can be 0, but not < 0!)
        persona = "orangesoda",     -- Persona to use
        melee_natk = "handsonic_melee", -- normal melee attack
 
        -- Normal attack attributes
        -- Scales with game difficulty
        atk = 40,   -- power (generally < 50)
        acc = 95,   -- accuracy (%)
        crit = 5,   -- crit rate (%)
 
        -- ANIMS
        -- Anims are built like this:
        -- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, ["SPR2_CONST"]}
        -- (SPR2 must be a string, and is optional. Only for use with SPR_PLAY)
 
        -- Note: As of Beta 1.0.0, not all animations are implemented
        -- (* = unimplemented)
 
        anim_stand =        {SPR_PLAY, A, 8, "SPR2_STND"},                  -- standing
        anim_stand_hurt =   {SPR_PLAY, A, 1, "SPR2_STND"},                  -- standing (low HP) *
        anim_stand_bored =  {SPR_PLAY, A, 8, "SPR2_STND"},                  -- standing (occasionally plays after anim_stand has played several times)
        anim_guard =        {SPR_PLAY, A, 1, "SPR2_GARD"},                  -- guarding
        anim_move =         {SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_WALK"},   -- moving
        anim_run =          {SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_RUN_"},   -- guess what
        anim_atk =          {SPR_PLAY, A, B, C, D, 2, "SPR2_ROLL"},         -- attacking
        anim_aoa_end =      {SPR_PLAY, D, C, B, A, 2, "SPR2_ROLL"},         -- jumping out of all-out attack
        anim_hurt =         {SPR_PLAY, A, 35, "SPR2_DEAD"},                 -- taking damage
        anim_getdown =      {SPR_PLAY, A, 1, "SPR2_CNT1"},                  -- knocked down from weakness / crit *
        anim_downloop =     {SPR_PLAY, A, 1, "SPR2_CNT1"},                  -- is down
        anim_getup =        {SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},         -- gets up from down
        anim_death =        {SPR_PLAY, A, 30, "SPR2_PAIN"},                 -- dies
        anim_revive =       {SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},         -- gets revived
 
        -- anim_special1 through anim_special32 may also be used for various purposes (ie: attack animations)
        anim_special1 =     {SPR_PLAY, A, TICRATE, "SPR2_MLEE"},
        anim_special4 =     {SPR_PLAY, A, TICRATE, "SPR2_GARD"},            -- guard
        anim_sepcial5 =     {SPR_PLAY, A, TICRATE, "SPR2_HWLP"},            -- howling prep
        anim_special6 =     {SPR_PLAY, A, B, 2, "SPR2_HOWL"},               -- howling
 
        -- VOICES
        -- Possible list of voices
        -- vfx_action = {"sfx_voice1", "sfx_voice2", [...], "sfx_voicen"}
 
        -- ...In the case of kanade, she's silent, but I will leave these here for reference!
 
        vfx_summon = {},    -- Summoning Persona to use a Skill
        vfx_skill = {},     -- Used a Skill
        vfx_item = {},      -- Used an item
        vfx_hurt = {},      -- Sustained damage
        vfx_hurtx = {},     -- Sustained heavy damage / Critical hit / Weakness
        vfx_die = {},       -- Death
        vfx_heal = {},      -- Healed by teammate
        vfx_healself = {},  -- Healed self
        vfx_kill = {},      -- Killed an enemy
        vfx_1more = {},     -- Performed 1more
        vfx_crit = {},      -- Cut-in for Weakness/Critical Hit
        vfx_aoaask = {},    -- Ask to All-Out Attack
        vfx_aoado = {},     -- Performing All-Out Attack
        vfx_aoarelent = {}, -- Relenting from All-Out Attack
        vfx_miss = {},      -- Missed attack
        vfx_dodge = {},     -- Dodged enemy attack
        vfx_win = {},       -- Battle won
        vfx_levelup = {},   -- Level Up!
 
 
        -- HUD DEFINTIIONS
 
        icon = "ICO_KANA",          -- head icon for character select
        hudbust = "H_KANBAR",           -- patch to draw on the stat hud
        hudaoa = "H_KANAOA",        -- patch for all out attack hud
        aoa_quote = "I shall be relentless.",
        hudcutin = "KANA_A",        -- cut in frames prefix
 
        -- Tip to display on the character select.
        -- Give insight on their skill type and their strengths/weaknesses in battle!
        tip = "Specializes in hard hitting Slash skills.\nShe is agile and has a good damage potential,\nhowever she is unable to sustain herself and\nappreciates buffs and healing from\na well rounded party.",
}
 
 
personaList["kanade"] = {
        -- GENERAL
        name = "Kanade",    -- Name of the Persona
        arcana = nil,           -- Arcana (unused in Beta 1.0.0, can be left nil as well)
 
        sprite = SPR_PSN0,      -- Unused outside of debugging purposes for shortcuts. Can be left nil
        startframe = 0,         -- Unused outside of debugging purposes for shortcuts. Can be left nil
 
        -- Animations function the same way they do for players. (In Kanade's case, she's so good she doesn't need one, so let's make it invisible)
        anim_idle =     {SPR_NULL, A},  -- Idle animation when summoned in the menu
        anim_atk =      {SPR_NULL, A},  -- Animation when attacking
 
        -- Stats (at level 10)
        -- Remember that stats naturally cap at 99.
        strength = 12,
        magic = 5,
        endurance = 7,
        luck = 4,
        agility = 10,
 
        -- Affinities (weak, resist, block, drain)
        weak = ATK_CURSE,
        resist = ATK_SLASH|ATK_BLESS,
        block = ATK_PIERCE,
 
        /*Skills learnt and their level:
            {
                {"skillname", level, ["skill_to_replace"]},
                {"skill2name", level, ["skill_to_replace"]},
                [...]
            }
 
            Documentation for every existing skill name will be available publically at a later date.
            For now, feel free to scout the game files yourself!
 
            the 3rd argument is only useful on higher difficulties where characters automatically start at
            higher levels, meaning their skills need to be automatically replaced.
 
            NOTE: Characters can only have 8 skills total! But if you mess this up, the game won't stop you from having 69 skills.
            So pay attention!
        */
 
        skills = {
                    {"cleave", 1}, {"skewer", 1},
                    {"counter", 12}, {"toxic slice", 16},
                    {"giant slice", 20}, {"cruel attack", 24},
                    {"gale slash", 27}, {"cut boost", 29},
 
                    {"counterstrike", 34, "counter"},
                    {"distortion", 40, "cleave"},
                    {"virus cutter", 43, "toxic slice"},
                    {"fatal end", 46, "skewer"},
                    {"howling", 50, "giant slice"},
 
                    {"blade of fury", 54, "gale slash"},
                    {"vile assault", 56, "cruel attack"},
                    {"cut amp", 58, "cut boost"},
                    {"delay", 60, "counterstrike"},
                    {"deathbound", 64, "blade of fury"},
 
                    {"brave blade", 73, "fatal end"},
                },
}
 
-- Finally, let us define our additional skills.
 
attackDefs["skewer"] = {
 
        name = "Skewer",                -- Name of the skill
        type = ATK_PIERCE,              -- Type of the skill (does not stack like affinities)
        power = 90,                     -- Power of the skill
        accuracy = 90,                  -- Accuracy (%) of the skill
        costtype = CST_HPPERCENT,       -- Cost type
        cost = 8,                       -- Cost
        critical = 5,                   -- Critical chance (%)
        desc = "Light Pierce damage to \none enemy.",   -- Description
        target = TGT_ENEMY,             -- Target type
 
        -- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
        /*
            targets is the table of originally targetted enemies
            hittargets is the table of enemies that were actually hit (ie: repels)
            timer is just a variable that will keep counting up each frame to aid in animating your attacks
 
            The animation ends when the function returns true.
            Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.
 
        */
 
        anim = function(mo, targets, hittargets, timer)
            local target = hittargets[1]
 
            if timer == 15
                local shot = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
                shot.state = S_STAB_1_1
                shot.color = SKINCOLOR_ORANGE
                shot.scale = FRACUNIT*3
                playSound(mo.battlen, sfx_hit)
 
                local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
                d.sprite = SPR_THMP
                d.frame = A|FF_FULLBRIGHT
                d.scale = FRACUNIT/4
                d.destscale = FRACUNIT*4
                d.scalespeed = FRACUNIT/8
                d.fuse = TICRATE-10
                d.tics = d.fuse
                d.momz = FRACUNIT*2
                d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
                d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
                d.color = SKINCOLOR_ORANGE
 
            elseif timer == 21
                playSound(mo.battlen, sfx_rail1)
                createSplat(mo)
                createSplat(mo)
                localquake(mo.battlen, FRACUNIT*10, 10)
                damageObject(target)    -- Damage our target
 
            elseif timer == 55
                return true
            end
        end,
}
 
attackDefs["handsonic_melee"] = {
        name = "Hand Sonic Ver. I",
        type = ATK_SLASH,
        power = 300,
        accuracy = 999,
        costtype = CST_HPPERCENT,
        technical = COND_FREEZE,
        cost = 4,
        critical = 5,
        physical = true,    -- Checking this uses the character atk/acc/crit stat instead of the attack's
        desc = "Light Slash damage to \none enemy.",
        target = TGT_ENEMY,
        anim = function(mo, targets, hittargets, timer)
 
            local target = hittargets[1]
 
            if timer == 1
                ANIM_set(mo, mo.anim_run)
                local g = P_SpawnGhostMobj(mo)
                g.colorized = true
 
                local cx = target.x + 168*cos(target.angle + ANG1*20)
                local cy = target.y + 168*sin(target.angle + ANG1*20)
                CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
                CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
                S_StartSound(mo, sfx_zoom)
 
            elseif R_PointToDist2(mo.x, mo.y, target.x, target.y) > FRACUNIT*64
            and mo.k_savetime == nil
                local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
                mo.angle = ang
                if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*192
                    ANIM_set(mo, mo.anim_special1)
                    P_InstaThrust(mo, ang, FRACUNIT*64)
                    if leveltime & 1
                        local g = P_SpawnGhostMobj(mo)
                        g.colorized = true
                    end
                else
                    P_InstaThrust(mo, ang, FRACUNIT*32)
                end
            elseif mo.k_savetime == nil -- attack connects
 
                mo.k_savetime = timer
 
                local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
                s.state = S_SLASHING_2_1
                s.color = SKINCOLOR_AETHER
                s.scale = FRACUNIT*3
                playSound(mo.battlen, sfx_slash)
                s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
                s.state = S_SLASHING_1_1
                s.color = SKINCOLOR_AETHER
                s.scale = FRACUNIT*3
                playSound(mo.battlen, sfx_slash)
 
            elseif timer == mo.k_savetime + 2
 
                damageObject(target)
                playSound(mo.battlen, sfx_bexpld)
                if not target.plyr
                    createSplat(mo)
                    createSplat(mo)
                end
                localquake(mo.battlen, FRACUNIT*10, 10)
                for i=1,10
                    local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
                    b.momx = P_RandomRange(-35, 35)*FRACUNIT
                    b.momy = P_RandomRange(-35, 35)*FRACUNIT
                    b.momz = P_RandomRange(-35, 35)*FRACUNIT
                    b.color = SKINCOLOR_RED
                    b.frame = A|FF_FULLBRIGHT
                    b.scale = FRACUNIT/2
                    b.destscale = FRACUNIT/12
                    b.tics = 35
                end
 
                local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
                s.sprite = SPR_SLSH
                s.frame = I|FF_FULLBRIGHT
                s.scale = FRACUNIT/2
                s.destscale = FRACUNIT*4
                s.scalespeed = FRACUNIT/3
                s.color = SKINCOLOR_AETHER
 
                s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
                s.sprite = SPR_SLSH
                s.frame = I|FF_FULLBRIGHT
                s.scale = FRACUNIT/2
                s.destscale = FRACUNIT*8
                s.scalespeed = FRACUNIT/2
                s.color = SKINCOLOR_AETHER
 
                s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
                s.sprite = SPR_SLSH
                s.frame = G|FF_FULLBRIGHT
                s.scale = FRACUNIT/2
                s.tics = TICRATE/2
                s.fuse = s.tics
                s.destscale = FRACUNIT*10
                s.scalespeed = FRACUNIT/4
                s.color = SKINCOLOR_AETHER
            elseif timer == mo.k_savetime + TICRATE
 
                mo.k_savetime = nil
                return true
            end
        end,
}
 
attackDefs["cut boost"] = {
        name = "Cut Boost",
        type = ATK_PASSIVE|ATK_SLASH,
        desc = "Boost Slash damage by 15%",
        power = 15,
        passive = PSV_BOOST,
}
 
attackDefs["cut amp"] = {
        name = "Cut Amp",
        type = ATK_PASSIVE|ATK_SLASH,
        desc = "Boost Slash damage by 30%",
        power = 30,
        passive = PSV_BOOST,
}
 
attackDefs["virus cutter"] = {
        name = "Virus Cutter",
        type = ATK_SLASH,
        power = 270,
        accuracy = 94,
        costtype = CST_HPPERCENT,
        cost = 15,
        critical = 3,
        status = COND_POISON,
        statuschance = 25,
        desc = "Medium Slash damage to \none enemy.\nSmall chance of Poison.",
        target = TGT_ENEMY,
        anim = function(mo, targets, hittargets, timer)
            local target = hittargets[1]
 
            if timer == 15
                local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
                s.state = S_SLASHING_2_1
                s.color = SKINCOLOR_PURPLE
                s.scale = FRACUNIT*3
                playSound(mo.battlen, sfx_slash)
 
            elseif timer == 17
                local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
                d.sprite = SPR_THMP
                d.frame = C|FF_FULLBRIGHT
                d.scale = FRACUNIT/4
                d.destscale = FRACUNIT*3
                d.scalespeed = FRACUNIT/8
                d.fuse = TICRATE-10
                d.tics = d.fuse
                d.momz = FRACUNIT*2
                d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
                d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
                d.color = SKINCOLOR_PURPLE
 
            elseif timer == 19
 
                damageObject(target)
                playSound(mo.battlen, sfx_bexpld)
                if not target.plyr
                    createSplat(mo)
                    createSplat(mo)
                end
                localquake(mo.battlen, FRACUNIT*10, 10)
                for i=1,10
                    local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
                    b.momx = P_RandomRange(-35, 35)*FRACUNIT
                    b.momy = P_RandomRange(-35, 35)*FRACUNIT
                    b.momz = P_RandomRange(-35, 35)*FRACUNIT
                    b.color = SKINCOLOR_PURPLE
                    b.frame = A|FF_FULLBRIGHT
                    b.scale = FRACUNIT/2
                    b.destscale = FRACUNIT/12
                    b.tics = 35
                end
 
                local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
                s.sprite = SPR_SLSH
                s.frame = I|FF_FULLBRIGHT
                s.scale = FRACUNIT/2
                s.destscale = FRACUNIT*4
                s.scalespeed = FRACUNIT/3
                s.color = SKINCOLOR_PURPLE
 
                s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
                s.sprite = SPR_SLSH
                s.frame = G|FF_FULLBRIGHT
                s.scale = FRACUNIT/2
                s.tics = TICRATE/2
                s.fuse = s.tics
                s.destscale = FRACUNIT*10
                s.scalespeed = FRACUNIT/4
                s.color = SKINCOLOR_PURPLE
 
            elseif timer == 45
                target.slashsprite = nil
                return true
            end
        end,
}

